﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private keys As String
	Private lblcut As B4XView
	Private ETCutA,ETCutB As EditText
	Private clv, clvB As CustomListView
	Private SD_Keyboard1 As SD_Keyboard
	Private Panel1 As Panel
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	keys = "A,B,C,D"
	SD_Keyboard1.SpecialKeyFont=xui.CreateMaterialIcons(16)
	
	Dim Ck As CustomKey
	Ck.Initialize
	Ck.AddEmptyRow
	Dim tsChrList As List
	tsChrList.Initialize
	For Each tsChr In Regex.Split(",",keys)
		tsChrList.Add(tsChr)
	Next
	For i = 0 To tsChrList.Size - 2
		Ck.AddKeyToLastRow(tsChrList.Get(i),Asc(tsChrList.Get(i)),tsChrList.Get(i) & tsChrList.Get(i+1),-10,1)
	Next
	Ck.AddKeyToLastRow(tsChrList.Get(tsChrList.Size - 1),Asc(tsChrList.Get(tsChrList.Size - 1)),tsChrList.Get(tsChrList.Size - 1),Asc(tsChrList.Get(tsChrList.Size - 1)),1)
	Ck.AddKeyToLastRow(SD_Keyboard1.keyShiftUp,Ck.CodeShift,SD_Keyboard1.keyShiftDown,Ck.CodeShift,1)
	Ck.AddEmptyRow
	Ck.AddKeyToLastRow("<<",-134,"<<",-134,1)
	Ck.AddKeytoLastRow("Search",-133,"Search",-133,2)
	Ck.AddKeyToLastRow(">>",-135,">>",-135,1)
	
	For i = 0 To 7
		Dim p As B4XView = xui.CreatePanel("")
		p.SetLayoutAnimated(0, 0, 0, 40dip, 40dip)
		p.LoadLayout("clvRow")
		lblcut.Text = i+1
		lblcut.TextColor = xui.Color_Gray
		ETCutA.Text = "A"
		SD_Keyboard1.Add(ETCutA,"ETCutA",Ck,Null)
		clv.Add(p,i)
	Next
	For i = 0 To 7
		Dim p As B4XView = xui.CreatePanel("")
		p.SetLayoutAnimated(0, 0, 0, 40dip, 40dip)
		p.LoadLayout("clvRowB")
		lblcut.Text = i+1
		lblcut.TextColor = xui.Color_Gray
		ETCutB.Text = "B"
		SD_Keyboard1.Add(ETCutB,"ETCutB",Ck,Null)
		clvB.Add(p,i)
	Next
	Dim pa As Panel = clv.GetPanel(0)
	pa.GetView(1).RequestFocus
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub Button1_Click
	xui.MsgboxAsync("Hello world!", "B4X")
End Sub

Private Sub ETCutA_TextChanged (Old As String, New As String)
	Dim ETCutAView As Object = Sender
	If ETCutAView Is EditText Then
		Dim position2 As Int = clv.GetItemFromView(ETCutAView)
		If position2 < clv.Size - 1 Then 'So that it does not crash when it is in the last EditText
			'Dim nextPanel As Panel = clv.GetPanel(position2 + 1)
			Dim nextEditText As EditText = clv.GetPanel(position2 + 1).GetView(1).Tag
			Sleep(10) 'this prevents the following error -> java.lang.IndexOutOfBoundsException: setSpan
			nextEditText.RequestFocus
			nextEditText.SelectAll
		End If
	End If
End Sub

Private Sub etcuta_focuschanged (HasFocus As Boolean)
	If HasFocus = True Then
		Dim ETCutAView As Object = Sender
		If ETCutAView Is EditText Then
			Dim position2 As Int = clv.GetItemFromView(ETCutAView)
			Dim nextPanel As Panel = clv.GetPanel(position2)
			Dim nextEditText As EditText = nextPanel.GetView(1).Tag
			Sleep(10) 'this prevents the following error -> java.lang.IndexOutOfBoundsException: setSpan
			nextEditText.SelectAll
		End If
	End If
End Sub

Private Sub ETCutA_CustomKey(Code As Int)
	Log(Code)
	If Code=-133 Then
		' my code'
		ToastMessageShow("Hello",True)
	End If
End Sub

Private Sub ETCutB_TextChanged (Old As String, New As String)

End Sub

Private Sub ETCutB_CustomKey(Code As Int)
	Log(Code)
	If Code=-133 Then
		' my code'
		ToastMessageShow("HelloB",True)
	End If
End Sub

Private Sub clv_ItemClick (Index As Int, Value As Object)
	ToastMessageShow("Clicked " & Index,False)
End Sub

Private Sub Panel1_Touch (Action As Int, X As Float, Y As Float)
	Dim pan As Object = Sender
	If pan Is Panel Then
		Dim position2 As Int = clv.GetItemFromView(pan)
		Dim nextEditText As EditText = clv.GetPanel(position2).GetView(1).Tag
		Sleep(10) 'this prevents the following error -> java.lang.IndexOutOfBoundsException: setSpan
		nextEditText.SelectAll
	End If
	
End Sub